local M = {}

local running = true

local vehicle = nil
local scenario = nil

local checkForPlayerCrash = false

local totalTime = 180 --seconds
local lastCountdownMsg = 11
local lastSeconds = false

local function reset()
    checkForPlayerCrash = false
    playerCrashTimeout = 0
    running = false
    lastSeconds = false
end

local function fail(reason)
    scenarios.finish({failed = reason})
    reset()
end

local function success()    
    local finalTime = scenario.timer
    local minutes = math.floor(finalTime / 60);
    local seconds = finalTime - (minutes * 60);
    local timeStr = ''
    if minutes > 0 then
        timeStr = string.format("%02.0f:%05.2f", minutes, seconds)
    else
        timeStr = string.format("%0.2f", seconds) .. 's'
    end
    local result = {msg = 'Well done, your time: '..timeStr}
    scenarios.finish(result)
    reset()
end

local function onRaceTick(raceTickTime)
	if not running then
        return
    end
    
    local playerData = map.objects.playerCar
	
    --Count down the time left when below 10 seconds
    local timeLeft = totalTime - scenario.timer
    if timeLeft < 11 then 
        lastSeconds = true
        local countdown = math.floor(timeLeft) + 1
        if countdown > 0 and lastCountdownMsg > countdown then
            guihooks.trigger('ScenarioFlashMessage', {{countdown..'...', 0.8}} )
            lastCountdownMsg = countdown
        end
    end
        
    if scenario.timer >= totalTime then
        fail('You ran out of time')
    end
end

local function onScenarioChange(sc)
    scenario = sc
end

M.onRaceStart = onRaceStart
M.onRaceTick = onRaceTick
M.onScenarioChange = onScenarioChange

return M